//  Giuseppe Vacanti (cosine science & computing bv)
//  March 13, 2003
// 
//   $Id: Hkparameter.h,v 1.2 2003/08/26 15:20:10 gvacanti Exp $

#ifndef HKPARAMETER_H
#define HKPARAMETER_H

#include<string>
#include<Xmm.h>
#include<SmartDal>
#include<vector>

class STime;
class Hkparameter_Descriptor;

class Hkparameter {
public:
  static Hkparameter * make(const Hkparameter_Descriptor &, unsigned hktolerate);
  static std::vector<Hkparameter *> get_parameters(Xmm::Instrument,
						   unsigned hktolerate);
  virtual std::string name() const = 0;
  virtual std::string colname() const = 0;
  virtual std::string condition() const = 0;
  virtual std::string description() const = 0;
  virtual Xmm::Instrument instrument() const = 0;
  virtual std::string value() const = 0;
  virtual void process(const SmartDal::TableH & table, const STime & start, const STime & stop) = 0;
  virtual bool is_set() const = 0;
  virtual Xmm::DataMode hktype() const = 0;
  virtual bool periodic() const = 0;
protected:
  virtual ~Hkparameter() {}
};

#endif
